> ## Documentation Index
> Fetch the complete documentation index at: https://ona.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Get ID Token

> Gets an ID token for authenticating with other services.

`Unary` · [`Identity`](/docs/api-reference/generated/identity/overview)

Gets an ID token for authenticating with other services.

Use this method to:

* Obtain authentication tokens for service-to-service calls
* Access protected resources
* Generate scoped access tokens

### Examples

* Get token for single service:

  Retrieves a token for authenticating with one service.

  ```yaml theme={null}
  audience:
    - "https://api.gitpod.io"
  ```

* Get token for multiple services:

  Retrieves a token valid for multiple services.

  ```yaml theme={null}
  audience:
    - "https://api.gitpod.io"
    - "https://ws.gitpod.io"
  ```

## Endpoint

```text theme={null}
POST /api/gitpod.v1.IdentityService/GetIDToken
```

Send a Bearer token as described in [Authentication](/docs/api-reference#authenticate-requests). If your organization uses a custom management-plane domain, replace `https://app.ona.com` with that domain.

## Request example

<CodeGroup>
  ```bash cURL theme={null}
  export ONA_HOST=https://app.ona.com
  export ONA_API_KEY=<your-token>

  curl --request POST \
    --url "$ONA_HOST/api/gitpod.v1.IdentityService/GetIDToken" \
    --header "Authorization: Bearer $ONA_API_KEY" \
    --header "Content-Type: application/json" \
    --data '{
    "audience": [
      "<audience>"
    ]
  }'
  ```

  ```python Python theme={null}
  import gitpod.v1.identity_pb2 as identity_pb2
  from ona_sdk import create_client_from_env

  ona = create_client_from_env()
  request = identity_pb2.GetIDTokenRequest(
      audience=["<audience>"],
  )
  response = ona.services.identity.get_id_token(request)
  print(response)
  ```

  ```typescript TypeScript theme={null}
  import { create } from "@bufbuild/protobuf";
  import { createClientFromEnv } from "@gitpod/sdk";
  import { GetIDTokenRequestSchema } from "@gitpod/sdk/gitpod/v1/identity_pb";

  async function main() {
    const ona = createClientFromEnv();
    const request = create(GetIDTokenRequestSchema, {
      audience: ["<audience>"],
    });
    const response = await ona.services.identity.getIDToken(request);
    console.log(response);
  }

  main().catch(console.error);
  ```

  ```go Go theme={null}
  package main

  import (
  	"context"
  	"fmt"
  	"log"

  	"connectrpc.com/connect"
  	"github.com/gitpod-io/gitpod-sdk-go/sdk"
  	gitpodpb "github.com/gitpod-io/gitpod-sdk-go/v1"
  )

  func main() {
  	ona, err := sdk.NewFromEnv()
  	if err != nil {
  		log.Fatal(err)
  	}

  	request := connect.NewRequest(&gitpodpb.GetIDTokenRequest{
  		Audience: []string{"<audience>"},
  	})
  	response, err := ona.Services.Identity.GetIDToken(context.Background(), request)
  	if err != nil {
  		log.Fatal(err)
  	}
  	fmt.Println(response.Msg)
  }
  ```

  ```json Request body theme={null}
  {
    "audience": [
      "<audience>"
    ]
  }
  ```
</CodeGroup>

## Request

`gitpod.v1.GetIDTokenRequest`

| Field      | Type                                               | Required | Description                             |
| ---------- | -------------------------------------------------- | -------- | --------------------------------------- |
| `audience` | array of string                                    | No       | Constraints: `repeated.min_items=1`.    |
| `version`  | [IDTokenVersion](#enum-gitpod-v1-id-token-version) | No       | version is the version of the ID token. |

## Response

`gitpod.v1.GetIDTokenResponse`

| Field   | Type   | Required | Description |
| ------- | ------ | -------- | ----------- |
| `token` | string | No       |             |

## Related types

<a id="enum-gitpod-v1-id-token-version" />

<Accordion title="IDTokenVersion">
  | Value                          | Number | Description                                  |
  | ------------------------------ | -----: | -------------------------------------------- |
  | `ID_TOKEN_VERSION_UNSPECIFIED` |      0 | When unspecified, the ID token version is 1. |
  | `ID_TOKEN_VERSION_V1`          |      1 |                                              |
  | `ID_TOKEN_VERSION_V2`          |      2 |                                              |
</Accordion>
